This patch provides --flags, which preserves the st_flags field.
Modified from a patch that was written by Rolf Grossmann.

To use this patch, run these commands for a successful build:

    patch -p1 <patches/flags.diff
    ./prepare-source
    ./configure
    make

TODO: fix --delete-delay to work with --flags option.

--- old/compat.c
+++ new/compat.c
@@ -63,6 +63,8 @@ void setup_protocol(int f_out,int f_in)
 		preserve_uid = ++file_extra_cnt;
 	if (preserve_gid)
 		preserve_gid = ++file_extra_cnt;
+	if (preserve_fileflags)
+		preserve_fileflags = ++file_extra_cnt;
 	if (preserve_acls && !am_sender)
 		preserve_acls = ++file_extra_cnt;
 
--- old/configure.in
+++ new/configure.in
@@ -559,7 +559,7 @@ AC_CHECK_FUNCS(waitpid wait4 getcwd strd
     memmove lchown vsnprintf snprintf vasprintf asprintf setsid glob strpbrk \
     strlcat strlcpy strtol mallinfo getgroups setgroups geteuid getegid \
     setlocale setmode open64 lseek64 mkstemp64 mtrace va_copy __va_copy \
-    strerror putenv iconv_open locale_charset nl_langinfo \
+    chflags strerror putenv iconv_open locale_charset nl_langinfo \
     sigaction sigprocmask)
 
 AC_CHECK_FUNCS(getpgrp tcgetpgrp)
--- old/flist.c
+++ new/flist.c
@@ -47,6 +47,7 @@ extern int preserve_links;
 extern int preserve_hard_links;
 extern int preserve_devices;
 extern int preserve_specials;
+extern int preserve_fileflags;
 extern int preserve_uid;
 extern int preserve_gid;
 extern int relative_paths;
@@ -352,6 +353,9 @@ static void send_file_entry(int f, struc
 {
 	static time_t modtime;
 	static mode_t mode;
+#ifdef SUPPORT_FLAGS
+	static uint32 fileflags;
+#endif
 	static int64 dev;
 	static dev_t rdev;
 	static uint32 rdev_major;
@@ -372,6 +376,12 @@ static void send_file_entry(int f, struc
 		flags |= XMIT_SAME_MODE;
 	else
 		mode = file->mode;
+#ifdef SUPPORT_FLAGS
+ 	if (F_FFLAGS(file) == fileflags)
+		flags |= XMIT_SAME_FLAGS;
+	else
+		fileflags = F_FFLAGS(file);
+#endif
 	if ((preserve_devices && IS_DEVICE(mode))
 	 || (preserve_specials && IS_SPECIAL(mode))) {
 		if (protocol_version < 28) {
@@ -485,6 +495,10 @@ static void send_file_entry(int f, struc
 		write_int(f, modtime);
 	if (!(flags & XMIT_SAME_MODE))
 		write_int(f, to_wire_mode(mode));
+#ifdef SUPPORT_FLAGS
+ 	if (preserve_fileflags && !(flags & XMIT_SAME_FLAGS))
+		write_int(f, (int)fileflags);
+#endif
 	if (preserve_uid && !(flags & XMIT_SAME_UID)) {
 		if (protocol_version < 30)
 			write_int(f, uid);
@@ -573,6 +587,9 @@ static struct file_struct *recv_file_ent
 {
 	static time_t modtime;
 	static mode_t mode;
+#ifdef SUPPORT_FLAGS
+ 	static uint32 fileflags;
+#endif
 	static int64 dev;
 	static dev_t rdev;
 	static uint32 rdev_major;
@@ -669,9 +686,12 @@ static struct file_struct *recv_file_ent
 		modtime = (time_t)read_int(f);
 	if (!(flags & XMIT_SAME_MODE))
 		mode = from_wire_mode(read_int(f));
-
 	if (chmod_modes && !S_ISLNK(mode))
 		mode = tweak_mode(mode, chmod_modes);
+#ifdef SUPPORT_FLAGS
+ 	if (preserve_fileflags && !(flags & XMIT_SAME_FLAGS))
+		fileflags = (uint32)read_int(f);
+#endif
 
 	if (preserve_uid && !(flags & XMIT_SAME_UID)) {
 		if (protocol_version < 30)
@@ -789,6 +809,10 @@ static struct file_struct *recv_file_ent
 		OPT_EXTRA(file, 0)->unum = (uint32)(file_length >> 32);
 	}
 	file->mode = mode;
+#ifdef SUPPORT_FLAGS
+	if (preserve_fileflags)
+		F_FFLAGS(file) = fileflags;
+#endif
 	if (preserve_uid)
 		F_OWNER(file) = uid;
 	if (preserve_gid)
@@ -1094,6 +1118,10 @@ struct file_struct *make_file(const char
 		OPT_EXTRA(file, 0)->unum = (uint32)(st.st_size >> 32);
 	}
 	file->mode = st.st_mode;
+#ifdef SUPPORT_FLAGS
+	if (preserve_fileflags)
+		F_FFLAGS(file) = st.st_flags;
+#endif
 	if (preserve_uid)
 		F_OWNER(file) = st.st_uid;
 	if (preserve_gid)
--- old/generator.c
+++ new/generator.c
@@ -111,6 +111,14 @@ static int dir_tweaking;
 static int need_retouch_dir_times;
 static const char *solo_file = NULL;
 
+#ifdef SUPPORT_FLAGS
+#define FF_PTR(p) F_FFLAGS(p)
+#define FF_STAT(s) s.st_flags
+#else
+#define FF_PTR(p) 0
+#define FF_STAT(s) 0
+#endif
+
 /* For calling delete_item() and delete_dir_contents(). */
 #define DEL_RECURSE		(1<<1) /* recurse */
 #define DEL_DIR_IS_EMPTY	(1<<2) /* internal delete_FUNCTIONS use only */
@@ -126,7 +134,6 @@ enum delret {
 /* Forward declaration for delete_item(). */
 static enum delret delete_dir_contents(char *fname, int flags);
 
-
 static int is_backup_file(char *fn)
 {
 	int k = strlen(fn) - backup_suffix_len;
@@ -139,17 +146,20 @@ static int is_backup_file(char *fn)
  * Note that fbuf must point to a MAXPATHLEN buffer if the mode indicates it's
  * a directory! (The buffer is used for recursion, but returned unchanged.)
  */
-static enum delret delete_item(char *fbuf, int mode, char *replace, int flags)
+static enum delret delete_item(char *fbuf, int mode, uint32 fileflags, char *replace, int flags)
 {
 	enum delret ret;
 	char *what;
 	int ok;
 
 	if (verbose > 2) {
-		rprintf(FINFO, "delete_item(%s) mode=%o flags=%d\n",
-			fbuf, mode, flags);
+		rprintf(FINFO, "delete_item(%s) mode=%o fileflags=%o flags=%d\n",
+			fbuf, mode, fileflags, flags);
 	}
 
+#ifdef SUPPORT_FLAGS
+	make_mutable(fbuf, mode, fileflags);
+#endif
 	if (S_ISDIR(mode) && !(flags & DEL_DIR_IS_EMPTY)) {
 		ignore_perishable = 1;
 		/* If DEL_RECURSE is not set, this just reports emptiness. */
@@ -261,7 +271,7 @@ static enum delret delete_dir_contents(c
 		if (S_ISDIR(fp->mode)
 		 && delete_dir_contents(fname, flags | DEL_RECURSE) != DR_SUCCESS)
 			ret = DR_NOT_EMPTY;
-		if (delete_item(fname, fp->mode, NULL, flags) != DR_SUCCESS)
+		if (delete_item(fname, fp->mode, FF_PTR(fp), NULL, flags) != DR_SUCCESS)
 			ret = DR_NOT_EMPTY;
 	}
 
@@ -317,8 +327,9 @@ static int remember_delete(struct file_s
 	
 	while (1) {
 		len = snprintf(deldelay_buf + deldelay_cnt,
-			       deldelay_size - deldelay_cnt,
-			       "%x %s%c", (int)file->mode, fname, '\0');
+			       deldelay_size - deldelay_cnt, "%x %x %s%c",
+			       (int)file->mode, (int)FF_PTR(file),
+			       fname, '\0');
 		if ((deldelay_cnt += len) <= deldelay_size)
 			break;
 		if (deldelay_fd < 0 && !start_delete_delay_temp())
@@ -331,7 +342,7 @@ static int remember_delete(struct file_s
 	return 1;
 }
 
-static int read_delay_line(char *buf)
+static int read_delay_line(char *buf, int *fileflags_p)
 {
 	static int read_pos = 0;
 	int j, len, mode;
@@ -373,7 +384,7 @@ static int read_delay_line(char *buf)
 
 	bp = deldelay_buf + read_pos;
 
-	if (sscanf(bp, "%x ", &mode) != 1) {
+	if (sscanf(bp, "%x %x ", &mode, fileflags_p) != 2) {
 	  invalid_data:
 		rprintf(FERROR, "ERROR: invalid data in delete-delay file.\n");
 		return -1;
@@ -396,15 +407,15 @@ static int read_delay_line(char *buf)
 
 static void do_delayed_deletions(char *delbuf)
 {
-	int mode;
+	int mode, fileflags;
 
 	if (deldelay_fd >= 0) {
 		if (deldelay_cnt && !flush_delete_delay())
 			return;
 		lseek(deldelay_fd, 0, 0);
 	}
-	while ((mode = read_delay_line(delbuf)) >= 0)
-		delete_item(delbuf, mode, NULL, DEL_RECURSE);
+	while ((mode = read_delay_line(delbuf, &fileflags)) >= 0)
+		delete_item(delbuf, mode, fileflags, NULL, DEL_RECURSE);
 	if (deldelay_fd >= 0)
 		close(deldelay_fd);
 }
@@ -472,7 +483,7 @@ static void delete_in_dir(struct file_li
 				if (!remember_delete(fp, delbuf))
 					break;
 			} else
-				delete_item(delbuf, fp->mode, NULL, DEL_RECURSE);
+				delete_item(delbuf, fp->mode, FF_PTR(fp), NULL, DEL_RECURSE);
 		}
 	}
 
@@ -1178,7 +1189,7 @@ static void recv_generator(char *fname, 
 		 * we need to delete it.  If it doesn't exist, then
 		 * (perhaps recursively) create it. */
 		if (statret == 0 && !S_ISDIR(sx.st.st_mode)) {
-			if (delete_item(fname, sx.st.st_mode, "directory", del_opts) != 0)
+			if (delete_item(fname, sx.st.st_mode, FF_STAT(sx.st), "directory", del_opts) != 0)
 				return;
 			statret = -1;
 		}
@@ -1291,7 +1302,7 @@ static void recv_generator(char *fname, 
 			}
 			/* Not the right symlink (or not a symlink), so
 			 * delete it. */
-			if (delete_item(fname, sx.st.st_mode, "symlink", del_opts) != 0)
+			if (delete_item(fname, sx.st.st_mode, FF_STAT(sx.st), "symlink", del_opts) != 0)
 				goto cleanup;
 		} else if (basis_dir[0] != NULL) {
 			int j = try_dests_non(file, fname, ndx, fnamecmpbuf, &sx,
@@ -1368,7 +1379,7 @@ static void recv_generator(char *fname, 
 					goto return_with_success;
 				goto cleanup;
 			}
-			if (delete_item(fname, sx.st.st_mode, t, del_opts) != 0)
+			if (delete_item(fname, sx.st.st_mode, FF_STAT(sx.st), t, del_opts) != 0)
 				goto cleanup;
 		} else if (basis_dir[0] != NULL) {
 			int j = try_dests_non(file, fname, ndx, fnamecmpbuf, &sx,
@@ -1457,7 +1468,7 @@ static void recv_generator(char *fname, 
 	fnamecmp_type = FNAMECMP_FNAME;
 
 	if (statret == 0 && !S_ISREG(sx.st.st_mode)) {
-		if (delete_item(fname, sx.st.st_mode, "regular file", del_opts) != 0)
+		if (delete_item(fname, sx.st.st_mode, FF_STAT(sx.st), "regular file", del_opts) != 0)
 			goto cleanup;
 		statret = -1;
 		stat_errno = ENOENT;
--- old/options.c
+++ new/options.c
@@ -48,6 +48,7 @@ int preserve_links = 0;
 int preserve_hard_links = 0;
 int preserve_acls = 0;
 int preserve_perms = 0;
+int preserve_fileflags = 0;
 int preserve_executability = 0;
 int preserve_devices = 0;
 int preserve_specials = 0;
@@ -203,6 +204,7 @@ static void print_rsync_version(enum log
 	char const *acls = "no ";
 	char const *links = "no ";
 	char const *ipv6 = "no ";
+ 	char const *fileflags = "no ";
 	STRUCT_STAT *dumstat;
 
 #ifdef HAVE_SOCKETPAIR
@@ -229,6 +231,10 @@ static void print_rsync_version(enum log
 	ipv6 = "";
 #endif
 
+#ifdef SUPPORT_FLAGS
+	fileflags = "";
+#endif
+
 	rprintf(f, "%s  version %s  protocol version %d\n",
 		RSYNC_NAME, RSYNC_VERSION, PROTOCOL_VERSION);
 	rprintf(f, "Copyright (C) 1996-2007 by Andrew Tridgell, Wayne Davison, and others.\n");
@@ -239,8 +245,8 @@ static void print_rsync_version(enum log
 		(int)(sizeof (int64) * 8));
 	rprintf(f, "    %ssocketpairs, %shardlinks, %ssymlinks, %sIPv6, batchfiles, %sinplace,\n",
 		got_socketpair, hardlinks, links, ipv6, have_inplace);
-	rprintf(f, "    %sappend, %sACLs\n",
-		have_inplace, acls);
+	rprintf(f, "    %sappend, %sACLs, %sfile-flags\n",
+		have_inplace, acls, fileflags);
 
 #ifdef MAINTAINER_MODE
 	rprintf(f, "Panic Action: \"%s\"\n", get_panic_action());
@@ -306,6 +312,7 @@ void usage(enum logcode F)
   rprintf(F," -K, --keep-dirlinks         treat symlinked dir on receiver as dir\n");
   rprintf(F," -H, --hard-links            preserve hard links\n");
   rprintf(F," -p, --perms                 preserve permissions\n");
+  rprintf(F,"     --fileflags             preserve file-flags\n");
   rprintf(F," -E, --executability         preserve the file's executability\n");
   rprintf(F,"     --chmod=CHMOD           affect file and/or directory permissions\n");
 #ifdef SUPPORT_ACLS
@@ -434,6 +441,8 @@ static struct poptOption long_options[] 
   {"perms",           'p', POPT_ARG_VAL,    &preserve_perms, 1, 0, 0 },
   {"no-perms",         0,  POPT_ARG_VAL,    &preserve_perms, 0, 0, 0 },
   {"no-p",             0,  POPT_ARG_VAL,    &preserve_perms, 0, 0, 0 },
+  {"fileflags",        0,  POPT_ARG_VAL,    &preserve_fileflags, 1, 0, 0 },
+  {"no-fileflags",     0,  POPT_ARG_VAL,    &preserve_fileflags, 0, 0, 0 },
   {"executability",   'E', POPT_ARG_NONE,   &preserve_executability, 0, 0, 0 },
   {"acls",            'A', POPT_ARG_NONE,   0, 'A', 0, 0 },
   {"no-acls",          0,  POPT_ARG_VAL,    &preserve_acls, 0, 0, 0 },
@@ -1166,6 +1175,15 @@ int parse_arguments(int *argc, const cha
 	}
 #endif
 
+#ifndef SUPPORT_FLAGS
+	if (preserve_fileflags) {
+		snprintf(err_buf, sizeof err_buf,
+			 "file flags are not supported on this %s\n",
+			 am_server ? "server" : "client");
+		return 0;
+	}
+#endif
+
 	if (write_batch && read_batch) {
 		snprintf(err_buf, sizeof err_buf,
 			"--write-batch and --read-batch can not be used together\n");
@@ -1629,6 +1647,9 @@ void server_options(char **args,int *arg
 	if (xfer_dirs && !recurse && delete_mode && am_sender)
 		args[ac++] = "--no-r";
 
+	if (preserve_fileflags)
+		args[ac++] = "--flags";
+
 	if (do_compression && def_compress_level != Z_DEFAULT_COMPRESSION) {
 		if (asprintf(&arg, "--compress-level=%d", def_compress_level) < 0)
 			goto oom;
--- old/rsync.c
+++ new/rsync.c
@@ -33,6 +33,7 @@ extern int verbose;
 extern int dry_run;
 extern int preserve_acls;
 extern int preserve_perms;
+extern int preserve_fileflags;
 extern int preserve_executability;
 extern int preserve_times;
 extern int omit_dir_times;
@@ -53,6 +54,8 @@ extern int make_backups;
 extern struct file_list *cur_flist, *first_flist, *dir_flist;
 extern struct chmod_mode_struct *daemon_chmod_modes;
 
+#define NOCHANGE_FLAGS (UF_IMMUTABLE|UF_APPEND|UF_NOUNLINK|SF_IMMUTABLE|SF_APPEND|SF_NOUNLINK)
+
 #if defined HAVE_ICONV_OPEN && defined HAVE_ICONV_H
 iconv_t ic_chck = (iconv_t)-1;
 
@@ -228,6 +231,41 @@ mode_t dest_mode(mode_t flist_mode, mode
 	return new_mode;
 }
 
+#ifdef SUPPORT_FLAGS
+/* Set a file's st_flags. */
+static int set_fileflags(const char *fname, uint32 fileflags)
+{
+	if (do_chflags(fname, fileflags) != 0) {
+		rsyserr(FERROR, errno,
+			"failed to set file flags on %s",
+			full_fname(fname));
+		return 0;
+	}
+
+	return 1;
+}
+
+/* Remove immutable flags from an object, so it can be altered/removed. */
+void make_mutable(char *fname, mode_t mode, uint32 fileflags)
+{
+	if (!preserve_fileflags && S_ISLNK(mode))
+		return;
+
+	if (fileflags & NOCHANGE_FLAGS)
+		set_fileflags(fname, fileflags & ~NOCHANGE_FLAGS);
+}
+
+/* Undo a prior make_mutable() call. */
+void undo_make_mutable(char *fname, mode_t mode, uint32 fileflags)
+{
+	if (!preserve_fileflags && S_ISLNK(mode))
+		return;
+
+	if (fileflags & NOCHANGE_FLAGS)
+		set_fileflags(fname, fileflags);
+}
+#endif
+
 int set_file_attrs(char *fname, struct file_struct *file, statx *sxp,
 		   int flags)
 {
@@ -346,6 +384,15 @@ int set_file_attrs(char *fname, struct f
 	}
 #endif
 
+#ifdef SUPPORT_FLAGS
+	if (preserve_fileflags && !S_ISLNK(sxp->st.st_mode)
+	 && sxp->st.st_flags != F_FFLAGS(file)) {
+		if (!set_fileflags(fname, F_FFLAGS(file)))
+			return 0;
+		updated = 1;
+	}
+#endif
+
 	if (verbose > 1 && flags & ATTRS_REPORT) {
 		if (updated)
 			rprintf(FCLIENT, "%s\n", fname);
@@ -398,6 +445,9 @@ void finish_transfer(char *fname, char *
 	set_file_attrs(fnametmp, file, NULL,
 		       ok_to_set_time ? 0 : ATTRS_SKIP_MTIME);
 
+#ifdef SUPPORT_FLAGS
+	make_mutable(fnametmp, file->mode, F_FFLAGS(file));
+#endif
 	/* move tmp file over real file */
 	if (verbose > 2)
 		rprintf(FINFO, "renaming %s to %s\n", fnametmp, fname);
@@ -412,6 +462,9 @@ void finish_transfer(char *fname, char *
 	}
 	if (ret == 0) {
 		/* The file was moved into place (not copied), so it's done. */
+#ifdef SUPPORT_FLAGS
+		undo_make_mutable(fname, file->mode, F_FFLAGS(file));
+#endif
 		return;
 	}
 	/* The file was copied, so tweak the perms of the copied file.  If it
--- old/rsync.h
+++ new/rsync.h
@@ -56,6 +56,7 @@
 #define XMIT_RDEV_MINOR_8_pre30 (1<<11)	/* protocols 28 - 29  */
 #define XMIT_GROUP_NAME_FOLLOWS (1<<11) /* protocols 30 - NOW */
 #define XMIT_HLINK_FIRST (1<<12)	/* protocols 30 - NOW */
+#define XMIT_SAME_FLAGS (1<<14)		/* protocols ?? - NOW */
 
 /* These flags are used in the live flist data. */
 
@@ -389,6 +390,10 @@ enum msgcode {
 #endif
 #endif
 
+#ifdef HAVE_CHFLAGS
+#define SUPPORT_FLAGS 1
+#endif
+
 /* Find a variable that is either exactly 32-bits or longer.
  * If some code depends on 32-bit truncation, it will need to
  * take special action in a "#if SIZEOF_INT32 > 4" section. */
@@ -568,6 +573,7 @@ struct file_struct {
 extern int file_extra_cnt;
 extern int preserve_uid;
 extern int preserve_gid;
+extern int preserve_fileflags;
 extern int preserve_acls;
 
 #define FILE_STRUCT_LEN (offsetof(struct file_struct, basename))
@@ -601,6 +607,7 @@ extern int preserve_acls;
 /* When the associated option is on, all entries will have these present: */
 #define F_OWNER(f) REQ_EXTRA(f, preserve_uid)->unum
 #define F_GROUP(f) REQ_EXTRA(f, preserve_gid)->unum
+#define F_FFLAGS(f) REQ_EXTRA(f, preserve_fileflags)->unum
 #define F_ACL(f) REQ_EXTRA(f, preserve_acls)->unum
 
 /* These items are per-entry optional and mutally exclusive: */
--- old/rsync.yo
+++ new/rsync.yo
@@ -321,6 +321,7 @@ to the detailed description below for a 
  -K, --keep-dirlinks         treat symlinked dir on receiver as dir
  -H, --hard-links            preserve hard links
  -p, --perms                 preserve permissions
+     --flags                 preserve file flags
  -E, --executability         preserve executability
      --chmod=CHMOD           affect file and/or directory permissions
  -A, --acls                  preserve ACLs (implies -p)
@@ -511,7 +512,9 @@ specified, in which case bf(-r) is not i
 
 Note that bf(-a) bf(does not preserve hardlinks), because
 finding multiply-linked files is expensive.  You must separately
-specify bf(-H).
+specify bf(-H).  Note also that for compatibility, bf(-a)
+currently bf(does not include --flags) (see there) to include preserving
+change file flags (if supported by the OS).
 
 dit(--no-OPTION) You may turn off one or more implied options by prefixing
 the option name with "no-".  Not all options may be prefixed with a "no-":
@@ -831,6 +834,13 @@ dit(bf(-A, --acls)) This option causes r
 ACLs to be the same as the source ACLs.  This nonstandard option only
 works if the remote rsync also supports it.  bf(--acls) implies bf(--perms).
 
+dit(bf(--flags)) This option causes rsync to update the change file flags
+to be the same as the source file, if your OS supports the bf(chflags)(2)
+system call.  In any case, an attempt is made to remove flags that would
+prevent a file to be altered.  Some flags can only be altered by the
+super-user and can only be unset below a certain secure-level (usually
+single-user mode).
+
 dit(bf(--chmod)) This option tells rsync to apply one or more
 comma-separated "chmod" strings to the permission of the files in the
 transfer.  The resulting value is treated as though it was the permissions
--- old/syscall.c
+++ new/syscall.c
@@ -152,6 +152,15 @@ int do_chmod(const char *path, mode_t mo
 }
 #endif
 
+#ifdef SUPPORT_FLAGS
+int do_chflags(const char *path, u_long flags)
+{
+	if (dry_run) return 0;
+	RETURN_ERROR_IF_RO_OR_LO;
+	return chflags(path, flags);
+}
+#endif
+
 int do_rename(const char *fname1, const char *fname2)
 {
 	if (dry_run) return 0;
